#include "user_input.h"

//////////////////////////////////////////////////////////////////////
// Mouse stuff
//
// This code doesn't care about the amount of buttons on a mouse.
// It simply reserves some more memory if a new mouse button gets
// used. It also isn't aware of any wheels (those are registered as
// buttons too).
//

static int		button_count = 0;
static byte*	buttons = NULL;

inline void ClearReleasedMousebuttons ()
{
	byte tmp;
	if (buttons != NULL)
		for (int i = 0; i < button_count; i++) {
			tmp = *(buttons + i);
			if ((tmp & BUTTON_RELEASED) == true)
				tmp = BUTTON_NONE;
			*(buttons + i) = tmp;
		}
}

inline void SetButtonState (byte button, byte state)
{
	if (button > button_count)
		buttons = realloc (buttons, button_count);
	*(buttons + (button - 1)) |= state
}

inline byte GetButtonState (byte button)
{
	return *(buttons + (button - 1));
}
